module mpost
USE mkinds
USE mstate
USE mutil
USE mncio
USE mpobs
USE mdates
USE mgrid
USE mens
USE mspmd, only : pid

contains

subroutine dopost(var)
IMPLICIT NONE
CHARACTER(Len=*)      :: var
REAL(r4)              :: fcst_bias,fcst_rms
REAL(r4)              :: analysis_bias,analysis_rms
INTEGER(i4)           :: i

SELECT CASE (var)

CASE("sst")
        if(nsst>0) then
        allocate(work_obs(nsst))
        work_obs(1:nsst)=gobs(1:nsst)
        call calculate_sst_residuals(work_obs,atem(:,:,1))
        gobs(1:nsst)%res=work_obs%res
        call com_mean(nsst,work_obs%inov,fcst_bias)
        call com_stdev(nsst,work_obs%inov,fcst_rms)
        call com_mean(nsst,work_obs%res,analysis_bias)
        call com_stdev(nsst,work_obs%res,analysis_rms)
   
WRITE(*,*) ".... SST forecast bias rms.....",fcst_bias,fcst_rms
WRITE(*,*) ".... SST analysis bias rms.....",analysis_bias,analysis_rms

        deallocate(work_obs)

        else
                WRITE(*,*) ".... no sst analysis ....."
        endif


CASE("sla")
        if(nsla>0) then
        allocate(work_obs(nsla))
        work_obs(1:nsla)=gobs(nsst+1:ntobs)
        call calculate_sla_residuals(work_obs,assh)
        gobs(nsst+1:ntobs)%res=work_obs%res
        call com_mean(nsla,work_obs%inov,fcst_bias)
        call com_stdev(nsla,work_obs%inov,fcst_rms)
        call com_mean(nsla,work_obs%res,analysis_bias)
        call com_stdev(nsla,work_obs%res,analysis_rms)
   
             WRITE(*,*) ".... SLA forecast bias rms.....",fcst_bias,fcst_rms
             WRITE(*,*) ".... SLA analysis bias rms.....",analysis_bias,analysis_rms

        deallocate(work_obs)
        else
             WRITE(*,*) ".... no sla analysis ....."       
        endif
CASE DEFAULT

        

END SELECT






end subroutine

SUBROUTINE calculate_sst_residuals(obs,asst)
implicit none
TYPE(tobs),INTENT(INOUT)         :: obs(:)
REAL(r4)                         :: asst(:,:)
integer(i4)                      :: i
REAL(r4)                         :: grdi
REAL(r4)                         :: grdj
REAL(r4)                         :: isst

do i=1,nsst
call blinterp(asst,nx,ny,obs(i)%gridi,obs(i)%gridj,isst)
obs(i)%res=obs(i)%val-isst
enddo

END SUBROUTINE



SUBROUTINE calculate_sla_residuals(obs,assh)
implicit none
TYPE(tobs),INTENT(INOUT)         :: obs(:)
REAL(r4)                         :: assh(:,:)
integer(i4)                      :: i
REAL(r4)                         :: grdi
REAL(r4)                         :: grdj
REAL(r4)                         :: isla

do i=1,nsla
call blinterp(assh,nx,ny,obs(i)%gridi,obs(i)%gridj,isla)
obs(i)%res=obs(i)%val-isla
enddo

END SUBROUTINE

END MODULE
