MODULE mstate
USE mkinds
USE mconstants
USE mgrid

IMPLICIT NONE

! partial states

REAL(r4), TARGET, ALLOCATABLE :: fssh(:,:)
REAL(r4), TARGET, ALLOCATABLE :: fsst(:,:)
REAL(r4), ALLOCATABLE         :: fsss(:,:)
REAL(r4), ALLOCATABLE         :: fmld(:,:)
REAL(r4), ALLOCATABLE         :: fuba(:,:)
REAL(r4), ALLOCATABLE         :: fvba(:,:)
REAL(r4), ALLOCATABLE         :: fpba(:,:)
REAL(r4), ALLOCATABLE         :: fuvl(:,:,:)
REAL(r4), ALLOCATABLE         :: fvvl(:,:,:)
REAL(r4), ALLOCATABLE         :: ftem(:,:,:)
REAL(r4), ALLOCATABLE         :: fsal(:,:,:)
REAL(r4), ALLOCATABLE         :: fden(:,:,:)
REAL(r4), ALLOCATABLE         :: fthk(:,:,:)
REAL(r4), ALLOCATABLE         :: fpin(:,:,:)
REAL(r4), ALLOCATABLE         :: fmgp(:,:,:)
REAL(r4), ALLOCATABLE         :: fpsikk(:,:,:)
REAL(r4), ALLOCATABLE         :: fthkk(:,:,:)
INTEGER(r4), ALLOCATABLE      :: mask2d(:,:)
REAL(r4), ALLOCATABLE         :: mask3d(:,:,:)
REAL(r4),ALLOCATABLE          :: work2d(:,:,:)
REAL(r4),ALLOCATABLE          :: work3d(:,:,:)
REAL(r4), ALLOCATABLE         :: fcst(:,:,:)
REAL(r4), ALLOCATABLE         :: fcst3d(:,:,:)
REAL(r4), ALLOCATABLE         :: b(:,:,:)
REAL(r4), ALLOCATABLE         :: e(:,:,:)
REAL(r4), ALLOCATABLE         :: idx(:,:)
REAL(r4), ALLOCATABLE         :: varb(:,:,:)
REAL(r4), ALLOCATABLE         :: fathk(:,:,:)
REAL(r4), ALLOCATABLE         :: ists(:,:)
REAL(r4), ALLOCATABLE         :: uf(:,:)
REAL(r4), ALLOCATABLE         :: vf(:,:)
REAL(r4), ALLOCATABLE         :: uvp(:,:)

! analyzed state

REAL(r4), TARGET, ALLOCATABLE :: assh(:,:)
REAL(r4), TARGET, ALLOCATABLE :: asst(:,:)
REAL(r4), ALLOCATABLE         :: asss(:,:)
REAL(r4), ALLOCATABLE         :: amld(:,:)
REAL(r4), ALLOCATABLE         :: auba(:,:)
REAL(r4), ALLOCATABLE         :: avba(:,:)
REAL(r4), ALLOCATABLE         :: apba(:,:)
REAL(r4), ALLOCATABLE         :: auvl(:,:,:)
REAL(r4), ALLOCATABLE         :: avvl(:,:,:)
REAL(r4), ALLOCATABLE         :: atem(:,:,:)
REAL(r4), ALLOCATABLE         :: asal(:,:,:)
REAL(r4), ALLOCATABLE         :: aden(:,:,:)
REAL(r4), ALLOCATABLE         :: athk(:,:,:)
REAL(r4), ALLOCATABLE         :: apin(:,:,:)
REAL(r4), ALLOCATABLE         :: amgp(:,:,:)
REAL(r4), ALLOCATABLE         :: apsikk(:,:,:)
REAL(r4), ALLOCATABLE         :: athkk(:,:,:)
REAL(r4), ALLOCATABLE         :: ua(:,:)
REAL(r4), ALLOCATABLE         :: va(:,:)
! int/tmp state

REAL(r4), TARGET, ALLOCATABLE :: issh(:,:)
REAL(r4), TARGET, ALLOCATABLE :: isst(:,:)
REAL(r4), ALLOCATABLE         :: isss(:,:)
REAL(r4), ALLOCATABLE         :: imld(:,:)
REAL(r4), ALLOCATABLE         :: iuba(:,:)
REAL(r4), ALLOCATABLE         :: ivba(:,:)
REAL(r4), ALLOCATABLE         :: ipba(:,:)
REAL(r4), ALLOCATABLE         :: iuvl(:,:,:)
REAL(r4), ALLOCATABLE         :: ivvl(:,:,:)
REAL(r4), ALLOCATABLE         :: item(:,:,:)
REAL(r4), ALLOCATABLE         :: isal(:,:,:)
REAL(r4), ALLOCATABLE         :: iden(:,:,:)
REAL(r4), ALLOCATABLE         :: ithk(:,:,:)
REAL(r4), ALLOCATABLE         :: iathk(:,:,:)
REAL(r4), ALLOCATABLE         :: ipin(:,:,:)
REAL(r4), ALLOCATABLE         :: imgp(:,:,:)
REAL(r4), ALLOCATABLE         :: ipsikk(:,:,:)
REAL(r4), ALLOCATABLE         :: ithkk(:,:,:)

! model type

character(:),allocatable      :: FCFileName
character(:),allocatable      :: fcmodel
character(:),allocatable      :: anlfileName
character(:),allocatable      :: mpfx
logical(bl)                   :: fcst_file_out
logical(bl)                   :: lglb

CONTAINS

SUBROUTINE malloc_state(start,count)
IMPLICIT NONE
INTEGER(i4)               :: start(3)
INTEGER(i4)               :: count(3)

ALLOCATE(fssh(count(1),count(2)))
ALLOCATE(fsst(count(1),count(2)))
ALLOCATE(fsss(count(1),count(2)))
ALLOCATE(fmld(count(1),count(2)))
ALLOCATE(fuba(count(1),count(2)))
ALLOCATE(fvba(count(1),count(2)))
ALLOCATE(fpba(count(1),count(2)))
ALLOCATE(fuvl(count(1),count(2),count(3)))
ALLOCATE(fvvl(count(1),count(2),count(3)))
ALLOCATE(fsal(count(1),count(2),count(3)))
ALLOCATE(ftem(count(1),count(2),count(3)))
ALLOCATE(fthk(count(1),count(2),count(3)))
ALLOCATE(fden(count(1),count(2),count(3)))
ALLOCATE(fmgp(count(1),count(2),count(3)))
ALLOCATE(fpsikk(count(1),count(2),2))
ALLOCATE(fthkk(count(1),count(2),2))
ALLOCATE(fpin(count(1),count(2),count(3)+1))
ALLOCATE(fathk(count(1),count(2),count(3)))
ALLOCATE(assh(count(1),count(2)))

allocate(uf(count(1),count(2)))
allocate(vf(count(1),count(2)))
allocate(ua(count(1),count(2)))
allocate(va(count(1),count(2)))

END SUBROUTINE

SUBROUTINE malloc_astate(start,count)
IMPLICIT NONE
INTEGER(i4)               :: start(3)
INTEGER(i4)               :: count(3)

!ALLOCATE(assh(count(1),count(2)))
!ALLOCATE(asst(count(1),count(2)))
!ALLOCATE(asss(count(1),count(2)))
!ALLOCATE(amld(count(1),count(2)))
!ALLOCATE(auba(count(1),count(2)))
!ALLOCATE(avba(count(1),count(2)))
!ALLOCATE(apba(count(1),count(2)))
!ALLOCATE(auvl(count(1),count(2),count(3)))
!ALLOCATE(avvl(count(1),count(2),count(3)))
ALLOCATE(asal(count(1),count(2),count(3)))
ALLOCATE(atem(count(1),count(2),count(3)))
ALLOCATE(athk(count(1),count(2),count(3)))
!ALLOCATE(fathk(count(1),count(2),count(3)))
ALLOCATE(aden(count(1),count(2),count(3)))
!ALLOCATE(amgp(count(1),count(2),count(3)))
!ALLOCATE(apsikk(count(1),count(2),2))
!ALLOCATE(athkk(count(1),count(2),2))
ALLOCATE(apin(count(1),count(2),count(3)+1))
atem=0.
asal=0.
athk=0.
!aden=0.
!assh=0.
!apin=0.
!auvl=0.
!avvl=0.
!auba=0.
!avba=0.
!work2d=0.
END SUBROUTINE

SUBROUTINE malloc_istate(start,count)
IMPLICIT NONE
INTEGER(i4)               :: start(3)
INTEGER(i4)               :: count(3)

ALLOCATE(issh(count(1),count(2)))
ALLOCATE(isst(count(1),count(2)))
ALLOCATE(isss(count(1),count(2)))
ALLOCATE(imld(count(1),count(2)))
ALLOCATE(iuba(count(1),count(2)))
ALLOCATE(ivba(count(1),count(2)))
ALLOCATE(ipba(count(1),count(2)))
ALLOCATE(iuvl(count(1),count(2),count(3)))
ALLOCATE(ivvl(count(1),count(2),count(3)))
ALLOCATE(isal(count(1),count(2),count(3)))
ALLOCATE(item(count(1),count(2),count(3)))
ALLOCATE(ithk(count(1),count(2),count(3)))
ALLOCATE(iathk(count(1),count(2),count(3)))
ALLOCATE(iden(count(1),count(2),count(3)))
ALLOCATE(imgp(count(1),count(2),count(3)))
ALLOCATE(ipsikk(count(1),count(2),2))
ALLOCATE(ithkk(count(1),count(2),2))
ALLOCATE(ipin(count(1),count(2),count(3)+1))
item=0.
isal=0.
ithk=0.
iden=0.
issh=0.
ipin=0.
iuvl=0.
ivvl=0.
iuba=0.
ivba=0.
work2d=0.
END SUBROUTINE

SUBROUTINE free_state()
IMPLICIT NONE

DEALLOCATE (fssh, fsst, fsss, fmld, fuba, fvba, work2d) 
DEALLOCATE (fuvl, fvvl, fsal, ftem, fthk, fden, fpin, mask2d, mask3d,work3d)

END SUBROUTINE

SUBROUTINE free_astate()
IMPLICIT NONE

DEALLOCATE (assh, asst, asss, auba, avba)
DEALLOCATE (auvl, avvl, asal, atem, athk, aden, apin)

END SUBROUTINE

SUBROUTINE getFCstate(FileName,fcmodel)
USE mdates
USE mhycom

IMPLICIT NONE
CHARACTER(*)              :: FileName
CHARACTER(*)              :: fcmodel
logical(bl)               :: lexist


IF (fcmodel .eq. 'hycom') THEN
 CALL readrst(FileName,nx,ny,nz,kapref,pref,thbase,thref,thflag,imask,fssh,fsst,fsss,fmld,fuba,fvba,fpba,fuvl,fvvl,fthk,ftem,fsal,fden,fthkk,fpsikk,fmgp,fpin)
ENDIF

END SUBROUTINE

END MODULE mstate
