module mverify
use mkinds
use mdates
use mncio
use mutil
use mseawater
use mgdem
use mgrid
use mhycom
use miotsis
use mpobs
use mabio
use mens

contains
      

       subroutine verify_dvel(u_bias,u_rmsd,v_bias,v_rmsd)
       implicit none

       character(:),allocatable        :: ct,fname,filename,dataFile,archvFile
       integer(i4)                     :: iunit,i,j,k,ii,jj,vcount,fid
       real(r4),allocatable            :: obs_u(:,:),model_u(:,:),eu(:,:),eu1d(:)
       real(r4),allocatable            :: obs_v(:,:),model_v(:,:),ev(:,:),ev1d(:)
       real(r4)                        :: u_bias,u_rmsd,v_bias,v_rmsd,hmin,hmax
       character(cl)                   :: buffer


       call initialize_analysis_grid()

       allocate(obs_u(nx,ny),model_u(nx,ny),eu(nx,ny),eu1d(nx*ny))
       allocate(obs_v(nx,ny),model_v(nx,ny),ev(nx,ny),ev1d(nx*ny))
       
       call getarg(2,buffer)
       dataFile=trim(buffer)

       call getarg(3,buffer)
       archvFile=trim(buffer)

       fname=dataFile
       call nciopn(fname,fid)
       call nciorv(fname,fid,"uc",obs_u)
       call nciorv(fname,fid,"vc",obs_v)
       call nciocl(fname,fid)

       !fname=archvFile
       !iunit=10
       !call zaiost(nx,ny)
       !call zaiopn(trim(fname),iunit)
       !do i=1,1
       !  call zaiosk(iunit)
       !enddo

       !call zaiord(iunit,model_sla,hmin,hmax)

       fname=archvFile
       call nciopn(fname,fid)
       call nciorv(fname,fid,"mixed_layer_u_velocity",model_u)
       call nciorv(fname,fid,"mixed_layer_v_velocity",model_v)
       call nciocl(fname,fid)

       eu=obs_u-model_u
       ev=obs_v-model_v

       vcount=0.0
       do j=1,ny
         do i=1,nx
           if(mdepth(i,j)<2.00**99 .and. obs_u(i,j)<2.00**99 .and. obs_v(i,j)<2.00**99) then
             vcount=vcount+1
             eu1d(vcount)=eu(i,j)
             ev1d(vcount)=ev(i,j)
           endif
        enddo
       enddo

       call com_stdev(vcount,eu1d(1:vcount),u_rmsd)
       call com_mean(vcount,eu1d(1:vcount),u_bias)

       call com_stdev(vcount,ev1d(1:vcount),v_rmsd)
       call com_mean(vcount,ev1d(1:vcount),v_bias)


       Write(*,*) u_bias,u_rmsd,v_bias,v_rmsd
       

       end subroutine

       subroutine verify_sla(sla_bias,sla_rmsd)
       implicit none

       character(:),allocatable        :: ct,fname,filename,dataFile,archvFile
       integer(i4)                     :: iunit,i,j,k,ii,jj,vcount,fid
       real(r4),allocatable            :: obs_sla(:,:),model_sla(:,:),err(:,:),e1d(:)
       real(r4)                        :: sla_bias,sla_rmsd,hmin,hmax
       character(cl)                   :: buffer
     

       call initialize_analysis_grid()
       allocate(obs_sla(nx,ny),model_sla(nx,ny),err(nx,ny),e1d(nx*ny))
       call getarg(2,buffer)
       dataFile=trim(buffer)

       call getarg(3,buffer)
       archvFile=trim(buffer)

       fname=dataFile
       call nciopn(fname,fid)
       call nciorv(fname,fid,"ssh",obs_sla)
       call nciocl(fname,fid)

       fname=archvFile
       iunit=10
       call zaiost(nx,ny)
       call zaiopn(trim(fname),iunit)
       do i=1,1
         call zaiosk(iunit)
       enddo

       call zaiord(iunit,model_sla,hmin,hmax)

       !fname=archvFile
       !call nciopn(fname,fid)
       !call nciorv(fname,fid,"ssh",model_sla)
       !call nciocl(fname,fid)

       !call smooth(model_sla,nx,ny,2.00**100,4) 
       err=obs_sla-model_sla*0.1

       vcount=0.0
       do j=1,ny
         do i=1,nx
           if(mdepth(i,j)>100.0 .and. mdepth(i,j)<2.00**99 .and. abs(err(i,j)) <1.0 ) then
             vcount=vcount+1
             e1d(vcount)=err(i,j)
           endif
        enddo
       enddo

       call com_stdev(vcount,e1d(1:vcount),sla_rmsd)
       call com_mean(vcount,e1d(1:vcount),sla_bias)


       end subroutine

      subroutine ncverify_sla(sla_bias,sla_rmsd)
       implicit none

       character(:),allocatable        :: ct,fname,filename,dataFile,archvFile
       integer(i4)                     :: iunit,i,j,k,ii,jj,vcount,fid
       real(r4),allocatable            :: obs_sla(:,:),model_sla(:,:),err(:,:),e1d(:)
       real(r4)                        :: sla_bias,sla_rmsd,hmin,hmax
       character(cl)                   :: buffer


       call initialize_analysis_grid()
       allocate(obs_sla(nx,ny),model_sla(nx,ny),err(nx,ny),e1d(nx*ny))
       call getarg(2,buffer)
       dataFile=trim(buffer)

       call getarg(3,buffer)
       archvFile=trim(buffer)

       fname=dataFile
       call nciopn(fname,fid)
       call nciorv(fname,fid,"ssh",obs_sla)
       call nciocl(fname,fid)

       fname=archvFile
       call nciopn(fname,fid)
       call nciorv(fname,fid,"ssh",model_sla)
       call nciocl(fname,fid)

       err=obs_sla-model_sla
        vcount=0.0
       do j=1,ny
         do i=1,nx
           if(mdepth(i,j)<2.00**99 .and. abs(err(i,j)) <2.0 ) then
             vcount=vcount+1
             e1d(vcount)=err(i,j)
           endif
        enddo
       enddo

       call com_stdev(vcount,e1d(1:vcount),sla_rmsd)
       call com_mean(vcount,e1d(1:vcount),sla_bias)


       end subroutine

       subroutine verify_sst(sst_bias,sst_rmsd)
       implicit none
       character(:),allocatable        :: ct,fname,filename,dataFile,archvFile
       integer(i4)                     :: iunit,i,j,k,ii,jj,vcount,fid
       real(r4),allocatable            :: obs_sst(:,:),model_sst(:,:),err(:,:),e1d(:)
       real(r4)                        :: sst_bias,sst_rmsd,hmin,hmax
       character(cl)                   :: buffer

       call initialize_analysis_grid()
       allocate(obs_sst(nx,ny),model_sst(nx,ny),err(nx,ny),e1d(nx*ny))


       call getarg(2,buffer)
       dataFile=trim(buffer)

       call getarg(3,buffer)
       archvFile=trim(buffer)

       fname=dataFile
       call nciopn(fname,fid)
       call nciorv(fname,fid,"sst",obs_sst)
       call nciocl(fname,fid)
      
       fname=archvFile
       iunit=10
       call zaiost(nx,ny)
       call zaiopn(trim(fname),iunit)
       do i=1,11
         call zaiosk(iunit)
       enddo

       call zaiord(iunit,model_sst,hmin,hmax)

       err=obs_sst-model_sst

       vcount=0.0
       do j=1,ny
         do i=1,nx
           if(mdepth(i,j)<2.00**99 .and. abs(err(i,j)) <10.0 ) then
             vcount=vcount+1
             e1d(vcount)=err(i,j)
           endif
        enddo
       enddo
 
       call com_stdev(vcount,e1d(1:vcount),sst_rmsd)
       call com_mean(vcount,e1d(1:vcount),sst_bias)

       !print *, sst_bias,sst_rmsd


       end subroutine

       subroutine ncverify_sst(sst_bias,sst_rmsd)
       implicit none
       character(:),allocatable        :: ct,fname,filename,dataFile,archvFile
       integer(i4)                     :: iunit,i,j,k,ii,jj,vcount,fid
       real(r4),allocatable            :: obs_sst(:,:),model_sst(:,:),err(:,:),e1d(:)
       real(r4)                        :: sst_bias,sst_rmsd,hmin,hmax
       character(cl)                   :: buffer

!       call initialize_analysis_grid()
       allocate(obs_sst(nx,ny),model_sst(nx,ny),err(nx,ny),e1d(nx*ny))


       call getarg(2,buffer)
       dataFile=trim(buffer)

       call getarg(3,buffer)
       archvFile=trim(buffer)

       fname=dataFile
       call nciopn(fname,fid)
       call nciorv(fname,fid,"sst",obs_sst)
       call nciocl(fname,fid)

       fname=archvFile
       call nciopn(fname,fid)
       call nciorv(fname,fid,"temp",model_sst,[1,1,1],[nx,ny,1])
       call nciocl(fname,fid)

       err=obs_sst-model_sst

       vcount=0.0
       do j=1,ny
         do i=1,nx
           if(mdepth(i,j)<2.00**99 .and. abs(err(i,j)) <10.0 ) then
             vcount=vcount+1
             e1d(vcount)=err(i,j)
           endif
        enddo
       enddo
 
       call com_stdev(vcount,e1d(1:vcount),sst_rmsd)
       call com_mean(vcount,e1d(1:vcount),sst_bias)

       !print *, sst_bias,sst_rmsd


       end subroutine



       subroutine verify_argo(date,cday,tcount,tbias,tstd,sbias,sstd)

implicit none

character(:),allocatable        ::  ct,filename,argoFile,archvFile,incupFile
integer(i4)                     ::  nskip,mt,iunit,i,k,j,fid,icount,vcount,kmx,tcount,gcount,lcount
real(r4),allocatable            ::  fcst_dp(:,:,:),fcst_tem(:,:,:),fcst_sal(:,:,:)
real(r4),allocatable            ::  anl_dp(:,:,:),anl_tem(:,:,:),anl_sal(:,:,:)
real(r4)                        ::  hmin,hmax,grdi,grdj,tbias,tstd,sbias,sstd
real(r4),allocatable            ::  ftem(:,:),fsal(:,:),lon(:),lat(:)
integer(i4),parameter           ::  nzlevs=52
real(r4)                        ::  tzlevs(nzlevs)
logical(bl)                     ::  lglb
real(r4),allocatable            ::  dp(:), pl(:),tl(:),sl(:),cdpth(:)
real(r4),allocatable            ::  atem(:,:),asal(:,:),m1lon(:),m1lat(:)
real(r4),allocatable            ::  terr(:,:),serr(:,:),gte(:),gse(:)
integer(i4),allocatable         ::  isvalid(:)
character(cl)                   ::  buffer
character(8)                    ::  date
character(3)                    ::  cday
character(:),allocatable        ::  out_f

nskip=18
! set target z levels
tzlevs=[0.,4., 8.,10.,15.,20.,25.,30.,35.,40.,45.,50.,60.,70.,80.,90.,100.,&
          110.,120.,130.,140.,150.,160.,170.,180.,190., 200.,210., 220.,230.,&
          240.,250.,260.,270., 280.,290.,300.,325.,350.,375.,400.,500.,600.,700.,&
          800.,900.,1000.,1200.,1400.,1600.,1800.,2000.]


call getarg(1,buffer)
argoFile=trim(buffer)

call getarg(3,buffer)
archvFile=trim(buffer)

!call getarg(2,buffer)
!incupFile=trim(buffer)


!call getarg(3,buffer)
!ct=trim(buffer)

!read(ct,'(i)') mt

!stop



lnmn=-180.0
lnmx=179.75
ltmn=-45.0
ltmx=45.0

out_f="dts"//argoFile(12:19)//".txt"

!find out the num of profiles

filename=argoFile
call nciopn(filename,fid)
call ncioin(filename,fid,"nprof",icount)

allocate(ftem(icount,nzlevs))
allocate(fsal(icount,nzlevs))
allocate(atem(icount,nzlevs))
allocate(asal(icount,nzlevs))
allocate(terr(icount,nzlevs))
allocate(serr(icount,nzlevs))
allocate(lon(icount))
allocate(lat(icount))
allocate(isvalid(icount))

call nciorv(filename,fid,"lon",lon)
call nciorv(filename,fid,"lat",lat)
call nciorv(filename,fid,"temp",atem)
call nciorv(filename,fid,"saln",asal)
!call nciorv(filename,fid,"ftem",ftem)
!call nciorv(filename,fid,"fsal",fsal)
!call nciorv(filename,fid,"isvalid",isvalid)
call nciocl(filename,fid)
!ftem=-999.0
!fsal=-999.0
! initialize grid

!call initialize_analysis_grid()

allocate(fcst_dp(nx,ny,nz))
allocate(fcst_tem(nx,ny,nz))
allocate(fcst_sal(nx,ny,nz))

!allocate(anl_dp(nx,ny,nz))
!allocate(anl_tem(nx,ny,nz))
!allocate(anl_sal(nx,ny,nz))


!allocate(mlon(nx,ny),mlat(nx,ny))


!!filename=archvFile

!!call nciopn(filename,fid)
!!call nciorv(filename,fid,"longitude",m1lon)
!!call nciorv(filename,fid,"latitude",m1lat)
!!call nciorv(filename,fid,"depth",cdpth)
!!call nciorv(filename,fid,"temperature",fcst_tem,[1,1,1,mt],[nx,ny,nz,1])
!!call nciorv(filename,fid,"salinity",fcst_sal,[1,1,1,mt],[nx,ny,nz,1])
!!call nciocl(filename,fid)


allocate(pl(nz+1),dp(nz),tl(nz),sl(nz),cdpth(nz))

!load forecast tem and sal

filename=archvFile
iunit=10
call zaiost(nx,ny)
call zaiopn(trim(Filename),iunit)
do i=1,nskip
call zaiosk(iunit)
enddo

do k=1,nz
call zaiosk(iunit)
call zaiosk(iunit)
call zaiosk(iunit)
call zaiord(iunit,fcst_dp(:,:,k),hmin,hmax)
call zaiord(iunit,fcst_tem(:,:,k),hmin,hmax)
call zaiord(iunit,fcst_sal(:,:,k),hmin,hmax)
call zaiosk(iunit)
enddo

call zaiocl(iunit)










!load forecast tem and sal

!filename=archvFile

!call nciopn(filename,fid)
!call nciorv(filename,fid,"depth",cdpth)
!call nciorv(filename,fid,"temperature",fcst_tem,[1,1,1,mt],[nx,ny,nz,1])
!call nciorv(filename,fid,"salinity",fcst_sal,[1,1,1,mt],[nx,ny,nz,1])
!call nciocl(filename,fid)

lglb=.true.
vcount=0
do i=1,icount
   if(lon(i)>lnmn .and. lon(i)<lnmx .and. lat(i)>ltmn .and. lat(i)<ltmx) then
   call lon_lat_idx(mlon,mlat,nx,ny,lon(i),lat(i),lglb,grdi,grdj)
   vcount=vcount+1
!write(*,*) i,lon(i),lat(i),grdi,grdj

         tl(:)=fcst_tem(int(grdi),int(grdj),:)
         sl(:)=fcst_sal(int(grdi),int(grdj),:)


         dp(:)=fcst_dp(int(grdi),int(grdj),:)
         tl(:)=fcst_tem(int(grdi),int(grdj),:)
         sl(:)=fcst_sal(int(grdi),int(grdj),:)
            pl(1)=0.0
         do k=1,nz
          pl(k+1)=pl(k)+dp(k)/9806.
          !print *, pl(k),tl(k),sl(k)
         enddo

        if(all(tl<2.00**99)) then
! get layer center depths

         do k=1,nz
           cdpth(k)=0.5*(pl(k+1)+pl(k))
!           print *, cdpth(k),tl(k),sl(k)
         enddo
         cdpth(1)=0.0
!         stop
         !if(all(tl>0.0)) then
         kmx=nzlevs
         do k=1,nzlevs
         if(tzlevs(k)>=cdpth(nz)) then
          kmx=k-1
          exit
         endif
         enddo

         call linint(nz,cdpth,tl,kmx,tzlevs(1:kmx),ftem(i,1:kmx))
         call linint(nz,cdpth,sl,kmx,tzlevs(1:kmx),fsal(i,1:kmx))

         else
         endif

         ftem(i,1)=tl(1)
         fsal(i,1)=sl(1)

         do k=1,nzlevs
          if(abs(atem(i,k)-ftem(i,k))>7.0 .or. abs(asal(i,k)-fsal(i,k))>2.0 ) then
          !write(*,'(9f12.3)') tzlevs(k),lon(i),lat(i),ftem(i,k),atem(i,k),fsal(i,k),asal(i,k),atem(i,k)-ftem(i,k),asal(i,k)-fsal(i,k)
          
!          write(*,'(i4,7f12.3)') vcount,tzlevs(k),lon(i),lat(i),atem(i,k),ftem(i,k),asal(i,k),fsal(i,k)

          fsal(i,k)=-999.0
          ftem(i,k)=-999.0

          endif
        enddo

endif   

enddo

tcount=0

do i=1,icount
!  vcount=0
if(lon(i)>lnmn .and. lon(i)<lnmx .and. lat(i)>ltmn .and. lat(i)<ltmx) then
   do k=1,nzlevs
    if(atem(i,k) /=-999.0 .and. ftem(i,k) /=-999.0) then
      terr(i,k)=atem(i,k)-ftem(i,k)
      serr(i,k)=asal(i,k)-fsal(i,k)
      vcount=vcount+1
      tcount=tcount+1
    else
      terr(i,k)=-999.0
      serr(i,k)=-999.0
    endif
   enddo
   !if(vcount>1) then 
   !call com_mean(vcount,terr(i,1:vcount),tbias)
   !call com_stdev(vcount,terr(i,1:vcount),tstd)
   
   endif 
enddo
deallocate(tl,sl)

!write(*,*) "********************************"
allocate(tl(tcount),sl(tcount))
open(unit=10,file=out_f,status="unknown")
do k=1,nzlevs
   lcount=0
   do i=1,icount
    if(lon(i)>lnmn .and. lon(i)<lnmx .and. lat(i)>ltmn .and. lat(i)<ltmx .and. terr(i,k)/=-999.0 .and. serr(i,k)/=-999.0) then
     lcount=lcount+1
     gcount=gcount+1
     tl(lcount)=terr(i,k)
     sl(lcount)=serr(i,k)
     endif
   enddo
     call com_mean(lcount,tl,tbias)
     call com_stdev(lcount,tl,tstd)
     call com_mean(lcount,sl,sbias)
     call com_stdev(lcount,sl,sstd)
     write(10,'(F10.2,4F12.6)') tzlevs(k),tbias,tstd,sbias,sstd
enddo
close(10)
!write(*,*) "********************************"
allocate(gte(tcount),gse(tcount))
vcount=0
do i=1,icount
if(lon(i)>lnmn .and. lon(i)<lnmx .and. lat(i)>ltmn .and. lat(i)<ltmx) then
   do k=1,nzlevs
    if(atem(i,k) /=-999.0 .and. ftem(i,k) /=-999.0) then
       vcount=vcount+1
      gte(vcount)=atem(i,k)-ftem(i,k)
      gse(vcount)=asal(i,k)-fsal(i,k)
    endif
   enddo
 endif
enddo




call com_mean(tcount,gte,tbias)
call com_stdev(tcount,gte,tstd)
call com_mean(tcount,gse,sbias)
call com_stdev(tcount,gse,sstd)

date=argoFile(12:20)
cday=archvFile(12:14)
!write(*,'(a8,2x,a3,2x,I9,4F12.4)') argoFile(12:20), archvFile(12:14), tcount,tbias,tstd,sbias,sstd

!filename=argoFile
!call nciopn(filename,fid)
!call nciowv(filename,fid,"ftem",ftem)
!call nciowv(filename,fid,"fsal",fsal)
!call nciocl(filename,fid)

end subroutine

subroutine ncverify_argo(date,cday,tcount,tbias,tstd,sbias,sstd)

implicit none

character(:),allocatable        ::  ct,filename,argoFile,archvFile,incupFile
integer(i4)                     ::  nskip,mt,iunit,i,k,j,fid,icount,vcount,kmx,tcount,gcount,lcount
real(r4),allocatable            ::  fcst_dp(:,:,:),fcst_tem(:,:,:),fcst_sal(:,:,:)
real(r4),allocatable            ::  anl_dp(:,:,:),anl_tem(:,:,:),anl_sal(:,:,:)
real(r4)                        ::  hmin,hmax,grdi,grdj,tbias,tstd,sbias,sstd
real(r4),allocatable            ::  ftem(:,:),fsal(:,:),lon(:),lat(:),rlon(:),rlat(:)
integer(i4),parameter           ::  nzlevs=52,nznc=37
real(r4)                        ::  tzlevs(nzlevs)
logical(bl)                     ::  lglb
real(r4),allocatable            ::  dp(:), pl(:),tl(:),sl(:),cdpth(:)
real(r4),allocatable            ::  atem(:,:),asal(:,:),m1lon(:),m1lat(:),etem(:,:),esal(:,:)
real(r4),allocatable            ::  terr(:,:),serr(:,:),gte(:),gse(:),error_temp(:,:,:),error_saln(:,:,:)
integer(i4),allocatable         ::  isvalid(:),np(:,:,:)
character(cl)                   ::  buffer
character(8)                    ::  date
character(3)                    ::  cday
character(:),allocatable        ::  out_f
integer(i4)                     ::  rnx,rny,fnx,fny
integer(i4)                     ::  vtype
integer(i4)                     ::  vdim2d(2),vdim1d(1),vdim3d(3)
character(:),allocatable        ::  vname
real(r4),allocatable            ::  flon(:),flat(:)
real(r4)                        ::  dmax
integer(i4)                     ::  nv

rnx=1440
rny=669

fnx=181
fny=91

allocate(flon(fnx))
allocate(flat(fny))


do i=1,fnx
   flon(i)=-180.0+(i-1)*2.0
enddo

do i=1,fny
   flat(i)=-90.0+(i-1)*2.0
  enddo




nskip=18
! set target z levels
tzlevs=[0.,4., 8.,10.,15.,20.,25.,30.,35.,40.,45.,50.,60.,70.,80.,90.,100.,&
          110.,120.,130.,140.,150.,160.,170.,180.,190., 200.,210., 220.,230.,&
          240.,250.,260.,270., 280.,290.,300.,325.,350.,375.,400.,500.,600.,700.,&
          800.,900.,1000.,1200.,1400.,1600.,1800.,2000.]


call getarg(1,buffer)
argoFile=trim(buffer)

call getarg(2,buffer)
archvFile=trim(buffer)

lnmn=-180.0
lnmx=179.75
ltmn=-70.0
ltmx=70.0


!find out the num of profiles

filename=argoFile
out_f="dts"//argoFile(12:19)//".txt"
call nciopn(filename,fid)
call ncioin(filename,fid,"nprof",icount)

allocate(ftem(icount,nzlevs))
allocate(fsal(icount,nzlevs))
allocate(atem(icount,nzlevs))
allocate(asal(icount,nzlevs))
allocate(terr(icount,nzlevs))
allocate(serr(icount,nzlevs))
allocate(lon(icount))
allocate(lat(icount))
allocate(isvalid(icount))
allocate(error_temp(fnx,fny,nzlevs))
allocate(error_saln(fnx,fny,nzlevs))
allocate(np(fnx,fny,nzlevs))

call nciorv(filename,fid,"lon",lon)
call nciorv(filename,fid,"lat",lat)
call nciorv(filename,fid,"temp",atem)
call nciorv(filename,fid,"saln",asal)

allocate(rlon(rnx),rlat(rny))
allocate(tl(nznc),sl(nznc),cdpth(nznc))
allocate(fcst_tem(rnx,rny,nznc))
allocate(fcst_sal(rnx,rny,nznc))

filename=archvFile

call nciopn(filename,fid)
call nciorv(filename,fid,"lon",rlon)
call nciorv(filename,fid,"lat",rlat)
call nciorv(filename,fid,"depth",cdpth)
call nciorv(filename,fid,"temp",fcst_tem)
call nciorv(filename,fid,"saln",fcst_sal)
call nciocl(filename,fid)


lglb=.false.
vcount=0
do i=1,icount
!   ftem(i,:)=-999.00
!   fsal(i,:)=-999.00
   tl=0.
   sl=0.
   if(lon(i)>lnmn .and. lon(i)<lnmx .and. lat(i)>ltmn .and. lat(i)<ltmx) then
   !call lon_lat_idx(mlon,mlat,nx,ny,lon(i),lat(i),lglb,grdi,grdj)
    grdi=ridx(rlon,lon(i))
    grdj=ridx(rlat,lat(i))
    vcount=vcount+1
    tl(1:nznc)=fcst_tem(int(grdi),int(grdj),1:nznc)
    sl(1:nznc)=fcst_sal(int(grdi),int(grdj),1:nznc)

         do k=2,nznc
          if(tl(k) > 2.00**99 .or. sl(k)>2.00**99) then
                  dmax=cdpth(k-1)
                  exit
          endif
          enddo

          
         kmx=nzlevs
         do k=1,nzlevs
         if(tzlevs(k)>dmax) then
          kmx=k-1
          exit
         endif
         enddo

         call linint(nznc,cdpth,tl,kmx,tzlevs(1:kmx),ftem(i,1:kmx))
         call linint(nznc,cdpth,sl,kmx,tzlevs(1:kmx),fsal(i,1:kmx))


         ftem(i,1)=tl(1)
         fsal(i,1)=sl(1)

         do k=1,nzlevs
          grdi=ridx(flon,lon(i))
          grdj=ridx(flat,lat(i))
          if(k>kmx .and. abs(atem(i,k)-ftem(i,k))>7.0 .or. abs(asal(i,k)-fsal(i,k))>2.0 ) then
          !write(*,'(9f12.3)') tzlevs(k),lon(i),lat(i),ftem(i,k),atem(i,k),fsal(i,k),asal(i,k),atem(i,k)-ftem(i,k),asal(i,k)-fsal(i,k)
!          write(*,'(i4,7f12.3)') vcount,tzlevs(k),lon(i),lat(i),atem(i,k),ftem(i,k),asal(i,k),fsal(i,k)

          fsal(i,k)=-999.0
          ftem(i,k)=-999.0
           error_temp(int(grdi),int(grdj),k)=0.0
           error_saln(int(grdi),int(grdj),k)=0.0

           else
           !write(*,'(9f12.3)') tzlevs(k),lon(i),lat(i),ftem(i,k),atem(i,k),fsal(i,k),asal(i,k),atem(i,k)-ftem(i,k),asal(i,k)-fsal(i,k)        
           np(int(grdi),int(grdj),k)=np(int(grdi),int(grdj),k)+1
           error_temp(int(grdi),int(grdj),k)=error_temp(int(grdi),int(grdj),k)+(atem(i,k)-ftem(i,k))
           error_saln(int(grdi),int(grdj),k)=error_saln(int(grdi),int(grdj),k)+(asal(i,k)-fsal(i,k))
           endif
           !print *, grdi,grdj,np(int(grdi),int(grdj),k),error_temp(int(grdi),int(grdj),k)
           enddo
   endif

   enddo

tcount=0

do i=1,icount
!  vcount=0
if(lon(i)>lnmn .and. lon(i)<lnmx .and. lat(i)>ltmn .and. lat(i)<ltmx) then
   do k=1,nzlevs
    if(atem(i,k) /=-999.0 .and. ftem(i,k) /=-999.0) then
      terr(i,k)=atem(i,k)-ftem(i,k)
      serr(i,k)=asal(i,k)-fsal(i,k)
      !vcount=vcount+1
      tcount=tcount+1
    else
      terr(i,k)=-999.0
      serr(i,k)=-999.0
    endif
   enddo
   !if(vcount>1) then 
   !call com_mean(vcount,terr(i,1:vcount),tbias)
   !call com_stdev(vcount,terr(i,1:vcount),tstd)

   endif
enddo
deallocate(tl,sl)

!write(*,*) "********************************"
allocate(tl(tcount),sl(tcount))
open(unit=10,file=out_f,status="unknown")
do k=1,nzlevs
   lcount=0
   do i=1,icount
    if(lon(i)>lnmn .and. lon(i)<lnmx .and. lat(i)>ltmn .and. lat(i)<ltmx .and. terr(i,k)/=-999.0 .and. serr(i,k)/=-999.0) then
     lcount=lcount+1
     !gcount=gcount+1
     tl(lcount)=terr(i,k)
     sl(lcount)=serr(i,k)
     endif
   enddo
     call com_mean(lcount,tl,tbias)
     call com_stdev(lcount,tl,tstd)
     call com_mean(lcount,sl,sbias)
     call com_stdev(lcount,sl,sstd)
     write(10,'(F10.2,4F12.6)') tzlevs(k),tbias,tstd,sbias,sstd
enddo
close(10)
!write(*,*) "********************************"
allocate(gte(tcount),gse(tcount))
vcount=0
do i=1,icount
if(lon(i)>lnmn .and. lon(i)<lnmx .and. lat(i)>ltmn .and. lat(i)<ltmx) then
   do k=1,nzlevs
    if(atem(i,k) /=-999.0 .and. ftem(i,k) /=-999.0) then
       vcount=vcount+1
      gte(vcount)=atem(i,k)-ftem(i,k)
      gse(vcount)=asal(i,k)-fsal(i,k)
    endif
   enddo
 endif
enddo

call com_mean(tcount,gte,tbias)
call com_stdev(tcount,gte,tstd)
call com_mean(tcount,gse,sbias)
call com_stdev(tcount,gse,sstd)

date=argoFile(12:20)
cday=archvFile(9:11)
!write(*,'(a8,2x,a3,2x,I9,4F12.4)') argoFile(12:20), archvFile(12:14), tcount,tbias,tstd,sbias,sstd

!filename=argoFile
!call nciopn(filename,fid)
!call nciowv(filename,fid,"ftem",ftem)
!call nciowv(filename,fid,"fsal",fsal)
!call nciocl(filename,fid)

!create file

      filename="argo_ts_stats_"//trim(date)//".nc"
     
      call nciocf(filename,fid)

      !create dimension and coordinate variable 1
      vname="lon"
      vtype=NF90_Float
      vdim1d(1)=1
      call nciodd(filename,fid,vname,fnx)
      call nciocv(filename,fid,vname,vtype,vdim1d)
      call nciowa(filename,fid,vname,'long_name','Longitude')
      call nciowa(filename,fid,vname,'standard_name','Longitude')
      call nciowa(filename,fid,vname,'units','degrees_east')

      !create dimension and coordinate variable 2
      vname="lat"
      vtype=NF90_Float
      vdim1d(1)=2
      call nciodd(filename,fid,vname,fny)
      call nciocv(filename,fid,vname,vtype,vdim1d)
      call nciowa(filename,fid,vname,'long_name','Latitude')
      call nciowa(filename,fid,vname,'standard_name','Latitude')
      call nciowa(filename,fid,vname,'units','degrees_north')

      !create dimension and coordinate variable 2
      vname="depth"
      vtype=NF90_Float
      vdim1d(1)=3
      call nciodd(filename,fid,vname,nzlevs)
      call nciocv(filename,fid,vname,vtype,vdim1d)
      call nciowa(filename,fid,vname,'long_name','depth')
      call nciowa(filename,fid,vname,'standard_name','depth')
      call nciowa(filename,fid,vname,'units','m')

      !create data variable 1
      vname="terr"
      vtype=NF90_Float
      vdim3d=(/1,2,3/)
      call nciocv(filename,fid,vname,vtype,vdim3d)
      call nciowa(filename,fid,vname,'long_name',"temperature_error")
      call nciowa(filename,fid,vname,'standard_name',"temperature_error")
      call nciowa(filename,fid,vname,'_FillValue',2.00**100)

      !create data variable 1
      vname="serr"
      vtype=NF90_Float
      vdim3d=(/1,2,3/)
      call nciocv(filename,fid,vname,vtype,vdim3d)
      call nciowa(filename,fid,vname,'long_name',"salinity_error")
      call nciowa(filename,fid,vname,'standard_name',"salinity_error")
      call nciowa(filename,fid,vname,'_FillValue',2.00**100)

      !create data variable 1
      vname="npts"
      vtype=NF90_Float
      vdim3d=(/1,2,3/)
      call nciocv(filename,fid,vname,vtype,vdim3d)
      call nciowa(filename,fid,vname,'long_name',"number_samples")
      call nciowa(filename,fid,vname,'standard_name',"number_samples")
      call nciowa(filename,fid,vname,'_FillValue',2.00**100)
      call ncioed(filename,fid)

      ! write data into variables
      call nciowv(filename,fid,"lon",flon)
      call nciowv(filename,fid,"lat",flat)
      call nciowv(filename,fid,"depth",tzlevs)
      call nciowv(filename,fid,"terr",error_temp)
      call nciowv(filename,fid,"serr",error_saln)
      call nciowv(filename,fid,"npts",real(np,r4))

      ! close file

      call nciocl(filename,fid)


end subroutine




end module mverify
